////////////////////////////////////////////////////////////////////
// BGSubtraction.pde
// 
// Dec.2004      Fujiyoshi Laboratory, Chubu Univ.
//               http://www.vision.cs.chubu.ac.jp/
////////////////////////////////////////////////////////////////////
import processing.video.*;
// ASỸp[^
char   subtracttype = 'a';                                              // Pxɂwip臒l = a, RGBxNg̊pxɂwip臒l = b
int    Th1 =20;                                                         // Pxɂwip臒l
float  Th2 =0.996;                                                      // RGBxNg̊pxɂwip臒l

// ̓Xg[IƉ摜TCYI
int input_stream = 1;							// Đ`I  摜(.jpg)t@C = 1, J = 2
int g_width = 320, g_height = 240;					// 摜TCY

// 摜t@C̃p[^
String prefix = "f";                                  			// 摜t@C̃vtBNX
String DIR = "WALK/";                          			// 摜t@C̃vtBNX
int frame_s = 1;                                   			// Jnt[
int frame_e = 528;                                    			// It[
int _fps = 30;                                        			// frame rate (default:30fps)

PImage curImg;                                        			// ݃t[摜ۑ
int frame;                                                              // ݃t[
int frame_flag;
PFont f;
boolean pause=true;
PImage previousImg, resultImg;
Capture video;

void setup(){
  frameRate(_fps);                                    			// t[[gݒ
  size(640, 240);                                     			// Window̃TCY
  // ̓Xg[摜t@C̏ꍇ
  if(input_stream == 1){
    frame = frame_s;
  }
  // ̓Xg[Jt@C̏ꍇ
  if(input_stream == 2){
//    beginVideo(g_width, g_height, _fps);              			// JTCYEt[[gݒ
    video = new Capture(this, g_width, g_height, _fps);
  }
    frame_flag = frame;
  f = loadFont("Helvetica-Bold-48.vlw");
  textFont( f, 16 );
} 

void captureEvent(Capture video){
  video.read();
}

void Init(){
  getNewImg();
//  previousImg = curImg.copy();
//  resultImg = curImg.copy();
  previousImg = new PImage(curImg.width, curImg.height);
  resultImg = new PImage(curImg.width, curImg.height);
  previousImg.copy(curImg, 0, 0, curImg.width, curImg.height, 0, 0, previousImg.width, previousImg.height);
  resultImg.copy(curImg, 0, 0, curImg.width, curImg.height, 0, 0, resultImg.width, previousImg.height);
  image(curImg, 0, 0);
}

void draw(){
  if(frame == frame_flag){
      Init();
  }
  if(pause){
//    previousImg = curImg.copy();
    previousImg.copy(curImg, 0, 0, curImg.width, curImg.height, 0, 0, previousImg.width, previousImg.height);
    getNewImg();
    if(subtracttype == 'a') resultImg =  Temporal_Differecing(previousImg, curImg);
    if(subtracttype == 'b') resultImg =  Temporal_Differecing_vector(previousImg, curImg);
  }
  image(curImg, 0, 0);
  image(resultImg, 320, 0);
  display_text();
}

/*-----------------------------------------------------------------------------------------------
 keyboardCxg
 -----------------------------------------------------------------------------------------------*/
void keyPressed(){
  if(key == ' ') pause = !pause;
  if(key =='+' || key == ';'){Th1=constrain(++Th1,0,255);Th2=constrain(Th2=Th2+0.001,0.5,1.0);}
  if(key =='-' || key == '='){Th1=constrain(--Th1,0,255);Th2=constrain(Th2=Th2-0.001,0.5,1.0);}
}

/*-----------------------------------------------------------------------------------------------
 text̏o
 -----------------------------------------------------------------------------------------------*/
void display_text(){
  fill(255,0,0);
  text("frame:"+nf(frame,4),10,230);                                        // t[ԍ̕`
  if(subtracttype == 'a')text("Th:"+nf(Th1,3),100,230);
  if(subtracttype == 'b')text("Th:"+nf((float)Th2,1,3),100,230);
}

void getNewImg(){
  // ̓Xg[摜t@C̏ꍇ
  if(input_stream == 1){
    String filename = DIR + prefix + nf(frame,4) + ".jpg";                  // t@CpXw, nf()4
    curImg = loadImage(filename);                                           // w摜ǂݍ 
    if(frame == frame_e){
      frame = frame_s;
    }else{
      frame = frame + 1;
    }
  }
  // ̓Xg[Jt@C̏ꍇ
  if(input_stream == 2){
    if(frame >= 18000){
      frame = 0;
    }
     frame = frame + 1;
    curImg=video;
  }
}

/*-----------------------------------------------------------------------------------------------
Px𗘗pwi@
 -----------------------------------------------------------------------------------------------*/       
PImage Temporal_Differecing(PImage I1, PImage I2)
{
//  PImage _out = I1.copy(); 
  PImage _out = new PImage(I1.width, I1.height);
  _out.copy(I1, 0, 0, I1.width, I1.height, 0, 0, _out.width, _out.height);
  int i, j, n = 0, dis;
  float dr, dg, db;
  color c;
  
  for(i=0; i<curImg.height; i++){
    for(j=0; j<curImg.width; j++){
      //vZ@sXn
      dr=  abs(red(I2.get(j,i))-red(I1.get(j,i)));
      dg = abs(green(I2.get(j,i))-green(I1.get(j,i)));
      db = abs(blue(I2.get(j,i))-blue(I1.get(j,i)));
        
      dis = (int)((dr+dg+db)/3.0);
        
      if(dis <Th1){
        c = color(255,255,255);  //wi:
        _out.set(j,i,c);    
      }else{
        c = color(255,0,0);      //ړ:
        _out.set(j,i,c);
      }
    }
  }
  
  return(_out);
}

/*-----------------------------------------------------------------------------------------------
RGBxNg𗘗pwi@
 -----------------------------------------------------------------------------------------------*/       
PImage Temporal_Differecing_vector(PImage I1, PImage I2)
{
//  PImage _out = I1.copy(); 
  PImage _out = new PImage(I1.width, I1.height);
  _out.copy(I1, 0, 0, I1.width, I1.height, 0, 0, _out.width, _out.height);
  int i, j, n = 0;
  double a, b, dis;
  double ab;
  color c;
  
  for(i=0; i<curImg.height; i++){
    for(j=0; j<curImg.width; j++){
      //aEbvZ
      ab = red(I1.get(j,i))*red(I2.get(j,i)) + green(I1.get(j,i))*green(I2.get(j,i)) + blue(I1.get(j,i))*blue(I2.get(j,i));
     //|a| |b|vZ
       a = sqrt(red(I1.get(j,i))*red(I1.get(j,i)) + green(I1.get(j,i))*green(I1.get(j,i)) + blue(I1.get(j,i))*blue(I1.get(j,i)));
       b = sqrt(red(I2.get(j,i))*red(I2.get(j,i)) + green(I2.get(j,i))*green(I2.get(j,i)) + blue(I2.get(j,i))*blue(I2.get(j,i)));
      //cosvZ
       dis=ab/(a*b);
       dis=dis*dis;
       
        
      if(dis > Th2){
        c = color(red(I1.get(j,i)),green(I1.get(j,i)),blue(I1.get(j,i)));
        _out.set(j,i,c);    
      }else{
        c = color(255,0,0);
        _out.set(j,i,c);
      }
    }
  }
  
  return(_out);
}
